## pianobooster 0.7.2

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.4)
if(COMMAND cmake_policy)
    cmake_policy(SET CMP0003 NEW)
endif(COMMAND cmake_policy)

# set project's name
PROJECT( pianobooster )

ADD_SUBDIRECTORY(src build)

=== src/CMakeLists.txt ===
# Cmake File for Piano Booster

option(USE_FTGL "build with ftgl" ON)
option(USE_JACK "build with Jack (Only required of BSD Unix)" OFF)
option(USE_BUNDLED_RTMIDI "build with bundled rtmidi (for older distributions only)" OFF)
option(USE_SYSTEM_FONT "build with system font" OFF)

cmake_minimum_required(VERSION 2.4)
if(COMMAND cmake_policy)
    cmake_policy(SET CMP0003 NEW)
endif(COMMAND cmake_policy)

if(WIN32)
    MESSAGE("GUI system is WIN32 ${CMAKE_GENERATOR}")
    SET(CMAKE_COLOR_MAKEFILE OFF)
endif(WIN32)

# set project's name
PROJECT( pianobooster )

cmake_policy(SET CMP0020 NEW)
cmake_policy(SET CMP0043 NEW)

# enable warnings
add_compile_options(-Wall)

if(USE_FONT)
    add_compile_options("-DUSE_FONT=\"${USE_FONT}\"")
endif()

add_compile_options("-DPREFIX=\"${CMAKE_INSTALL_PREFIX}\"")

if(NOT DATA_DIR)
    set(DATA_DIR "share/games/pianobooster")
endif()
add_compile_options("-DDATA_DIR=\"${DATA_DIR}\"")

if(NOT CMAKE_INSTALL_BINDIR)
  set(CMAKE_INSTALL_BINDIR "bin")
endif()

MESSAGE("PREFIX: " ${CMAKE_INSTALL_PREFIX})
MESSAGE("DATA_DIR: " ${DATA_DIR})
MESSAGE("CMAKE_INSTALL_BINDIR: " ${CMAKE_INSTALL_BINDIR})

FIND_PACKAGE( OpenGL REQUIRED )

include(FindPkgConfig)
FIND_PACKAGE( PkgConfig REQUIRED )

if(USE_FTGL)
   pkg_check_modules(FTGL ftgl)
   if(NOT FTGL_FOUND)
      MESSAGE(FATAL_ERROR "FTGL was not found")
   endif(NOT FTGL_FOUND)

   SET(FTGL_INCLUDE_DIR ${FTGL_INCLUDE_DIRS})
   SET(FTGL_LIBRARY ${FTGL_LIBRARIES})
else(USE_FTGL)
    add_compile_options("-DNO_USE_FTGL")
endif(USE_FTGL)

if(NO_LANGS)
    add_compile_options("-DNO_LANGS")
endif()

# Finds Qt5 libraries
FIND_PACKAGE( Qt5 REQUIRED COMPONENTS Core Gui Widgets LinguistTools OpenGL Xml )

add_compile_options(-fPIC)

# Add in the link libraries for each operating system
if(${CMAKE_SYSTEM} MATCHES "Linux")
    ADD_DEFINITIONS(-D__LINUX_ALSA__)
    LINK_LIBRARIES (asound)
    LINK_LIBRARIES (pthread)
    LINK_LIBRARIES (GL)
endif(${CMAKE_SYSTEM} MATCHES "Linux")

if(${CMAKE_SYSTEM} MATCHES "Windows")
    ADD_DEFINITIONS(-D__WINDOWS_MM__ -D_WIN32)
    LINK_LIBRARIES(winmm opengl32)
endif(${CMAKE_SYSTEM} MATCHES "Windows")

if(${CMAKE_SYSTEM} MATCHES "Darwin")
    ADD_DEFINITIONS(-D__MACOSX_CORE__)
    LINK_LIBRARIES("-framework CoreMidi -framework CoreAudio -framework CoreFoundation -framework OpenGL")
endif(${CMAKE_SYSTEM} MATCHES "Darwin")

if(EXPERIMENTAL_USE_FLUIDSYNTH)
    ADD_DEFINITIONS(-DEXPERIMENTAL_USE_FLUIDSYNTH)
    MESSAGE("Building using fluidsynth")
    SET( PB_BASE_SRCS MidiDeviceFluidSynth.cpp )

    if(FLUIDSYNTH_INPLACE_DIR)
        INCLUDE_DIRECTORIES(${FLUIDSYNTH_INPLACE_DIR}/include/)
        if(WIN32)
            LINK_LIBRARIES( ${FLUIDSYNTH_INPLACE_DIR}/src/.libs/libfluidsynth.dll.a)
        endif(WIN32)
        if(UNIX)
            LINK_LIBRARIES(${FLUIDSYNTH_INPLACE_DIR}/src/.libs/libfluidsynth.so)
        endif(UNIX)
    else(FLUIDSYNTH_INPLACE_DIR)
        pkg_check_modules(FLUIDSYNTH fluidsynth)
        if(NOT FLUIDSYNTH_FOUND)
            MESSAGE(FATAL_ERROR "FLUIDSYNTH was not found")
        endif(NOT FLUIDSYNTH_FOUND)
        LINK_LIBRARIES( fluidsynth)
    endif(FLUIDSYNTH_INPLACE_DIR)
endif(EXPERIMENTAL_USE_FLUIDSYNTH)

# we need this to be able to include headers produced by uic in our code
# (CMAKE_BINARY_DIR holds a path to the build directory, while INCLUDE_DIRECTORIES() works just like INCLUDEPATH from qmake)
INCLUDE_DIRECTORIES(${CMAKE_CURRENT_BINARY_DIR} ${CMAKE_BINARY_DIR} ${OPENGL_INCLUDE_DIR} ${FTGL_INCLUDE_DIR})

SET(PB_BASE_SRCS MidiFile.cpp MidiTrack.cpp Song.cpp Conductor.cpp Util.cpp
    Chord.cpp Tempo.cpp MidiDevice.cpp MidiDeviceRt.cpp ${PB_BASE_SRCS})
SET(PB_BASE_HDR MidiFile.h MidiTrack.h Song.h Conductor.h Rating.h Util.h
    Chord.h Tempo.h MidiDevice.h)


if(USE_JACK)
    # Check for Jack
    find_library(JACK_LIB jack)
    pkg_check_modules(JACK jack)
    if(NOT JACK_FOUND)
        MESSAGE(FATAL_ERROR "JACK was not found")
    endif(NOT JACK_FOUND)

    SET(JACK_INCLUDE_DIR ${JACK_INCLUDE_DIRS})
    SET(JACK_LIBRARY ${JACK_LIBRARIES})
    if(JACK_FOUND)
        ADD_DEFINITIONS(-D__UNIX_JACK__)
    endif(JACK_FOUND)
endif(USE_JACK)

if(USE_BUNDLED_RTMIDI)
    message(STATUS "Building using bundled rtmidi")
    add_compile_options("-DUSE_BUNDLED_RTMIDI")
    include_directories("3rdparty")
    set(PB_BASE_SRCS ${PB_BASE_SRCS} 3rdparty/rtmidi/RtMidi.cpp)
    set(PB_BASE_HDR ${PB_BASE_HDR} 3rdparty/rtmidi/RtMidi.h)
else()
    pkg_check_modules(RTMIDI REQUIRED rtmidi)
    include_directories(${RTMIDI_INCLUDE_DIRS})
    link_directories(${RTMIDI_LIBRARY_DIRS})
endif()

# with SET() command you can change variables or define new ones
# here we define PIANOBOOSTER_SRCS variable that contains a list of all .cpp files
# note that we don't need \ at the end of line
SET( PIANOBOOSTER_SRCS
    QtMain.cpp
    QtWindow.cpp
    GuiTopBar.cpp
    GuiSidePanel.cpp
    GuiMidiSetupDialog.cpp
    GuiKeyboardSetupDialog.cpp
    GuiPreferencesDialog.cpp
    GuiSongDetailsDialog.cpp
    GuiLoopingPopup.cpp
    GlView.cpp
    ${PB_BASE_SRCS}
    StavePosition.cpp
    Score.cpp
    Cfg.cpp
    Piano.cpp
    Draw.cpp
    Scroll.cpp
    Notation.cpp
    TrackList.cpp
    Rating.cpp
    Bar.cpp
    Settings.cpp
    Merge.cpp
    pianobooster.rc
    images/pianobooster.ico
)

# another list, this time it includes all header files that should be treated with moc
SET( PIANOBOOSTER_MOC_HDRS
    QtWindow.h
    GlView.h
    GuiTopBar.h
    GuiSidePanel.h
    GuiMidiSetupDialog.h
    GuiKeyboardSetupDialog.h
    GuiPreferencesDialog.h
    GuiSongDetailsDialog.h
    GuiLoopingPopup.h
)

# some .ui files
SET( PIANOBOOSTER_UIS
    ./GuiTopBar.ui
    ./GuiSidePanel.ui
    ./GuiMidiSetupDialog.ui
    ./GuiKeyboardSetupDialog.ui
    ./GuiPreferencesDialog.ui
    ./GuiSongDetailsDialog.ui
    ./GuiLoopingPopup.ui
)

# and finally an resource file
SET( PIANOBOOSTER_RCS
    ./application.qrc
)

set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTOUIC ON)
set(CMAKE_AUTORCC ON)
set(CMAKE_INCLUDE_CURRENT_DIR ON)

# here we instruct CMake to build "pianobooster" executable from all of the source files
if(APPLE)
    ADD_EXECUTABLE( pianobooster MACOSX_BUNDLE ${PIANOBOOSTER_SRCS}
        ${PIANOBOOSTER_MOC_SRCS} ${PIANOBOOSTER_RC_SRCS}
        ${PIANOBOOSTER_UI_HDRS} ${PIANOBOOSTER_RCS} )
endif(APPLE)

if(UNIX)
    ADD_EXECUTABLE( pianobooster ${PIANOBOOSTER_SRCS}
        ${PIANOBOOSTER_MOC_SRCS} ${PIANOBOOSTER_RC_SRCS}
        ${PIANOBOOSTER_UI_HDRS} ${PIANOBOOSTER_RCS} )
endif(UNIX)

if(WIN32)
    ADD_EXECUTABLE( pianobooster WIN32 ${PIANOBOOSTER_SRCS}
        ${PIANOBOOSTER_MOC_SRCS} ${PIANOBOOSTER_RC_SRCS}
        ${PIANOBOOSTER_UI_HDRS} ${PIANOBOOSTER_RCS} )
    SET_TARGET_PROPERTIES(pianobooster PROPERTIES LINK_FLAGS "-mwindows")
endif(WIN32)

qt5_use_modules(pianobooster Core Gui Widgets LinguistTools OpenGL Xml)

if(${CMAKE_VERSION} VERSION_LESS "3.13.0")
    message("Please consider to switch to CMake 3.13.0")
else()
    target_link_directories(pianobooster PUBLIC ${FTGL_LIBRARY_DIRS} ${JACK_LIBRARY_DIRS})
endif()
target_link_libraries (pianobooster Qt5::Widgets Qt5::Xml Qt5::OpenGL ${OPENGL_LIBRARIES} ${FTGL_LIBRARY} ${RTMIDI_LIBRARIES} ${JACK_LIBRARY})

INSTALL( FILES ../pianobooster.desktop DESTINATION share/applications )
INSTALL(TARGETS pianobooster RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR})

if(NOT NO_DOCS)
    INSTALL( FILES ../README.md DESTINATION share/doc/pianobooster/ )
    INSTALL( FILES ../doc/faq.md DESTINATION share/doc/pianobooster/ )
endif()

if(NOT NO_LICENSE)
    INSTALL( FILES ../license.txt DESTINATION share/licenses/pianobooster/ )
endif()

if(NOT NO_CHANGELOG)
    INSTALL( FILES ../Changelog.txt DESTINATION share/doc/pianobooster/ )
endif()

if(WITH_MAN)
    INSTALL( FILES ../pianobooster.6  DESTINATION share/man/man6/ )
endif()

INSTALL ( FILES ../icons/hicolor/32x32/pianobooster.png DESTINATION share/icons/hicolor/32x32/apps )
INSTALL ( FILES ../icons/hicolor/48x48/pianobooster.png DESTINATION share/icons/hicolor/48x48/apps )
INSTALL ( FILES ../icons/hicolor/64x64/pianobooster.png DESTINATION share/icons/hicolor/64x64/apps )

if(UNIX AND NOT APPLE)
    INSTALL ( FILES ../music/BoosterMusicBooks.zip DESTINATION ${DATA_DIR}/music )
endif(UNIX AND NOT APPLE)

if(WIN32)
    INSTALL( FILES ../music/BoosterMusicBooks.zip DESTINATION . )
endif(WIN32)

if(USE_FONT)
    INSTALL ( FILES ${USE_FONT} DESTINATION ${DATA_DIR}/fonts)
endif(USE_FONT)

if(NOT USE_SYSTEM_FONT)
    INSTALL ( FILES fonts/DejaVuSans.ttf DESTINATION ${DATA_DIR}/fonts)
endif(NOT USE_SYSTEM_FONT)

if(NOT NO_LANGS)
    ADD_SUBDIRECTORY(../translations ../build/translations)
endif(NOT NO_LANGS)

if(DEBUG_LOG_TRACE)
    ADD_DEFINITIONS(-DPB_LOG_TRACE)
endif()

if(DEBUG_LOG_TIMING)
    ADD_DEFINITIONS(-DPB_LOG_TIMING)
endif()

=== translations/CMakeLists.txt ===
SET( TRANSLATIONS_FILES
     pianobooster_ca.ts
     pianobooster_cs.ts
     pianobooster_da.ts
     pianobooster_de.ts
     pianobooster_es.ts
     pianobooster_fr.ts
     pianobooster_gl.ts
     pianobooster_is.ts
     pianobooster_it.ts
     pianobooster_ja.ts
     pianobooster_nb.ts
     pianobooster_nl.ts
     pianobooster_pl.ts
     pianobooster_ru.ts
     pianobooster_sk.ts
     pianobooster_sv.ts
     pianobooster_uk.ts
     pianobooster_zh.ts
     music_ru.ts
     music_uk.ts
)

if(INSTALL_ALL_LANGS)
file (GLOB TRANSLATIONS_FILES "*.ts")   
endif()

get_filename_component(full_path_blank_ts ${CMAKE_CURRENT_SOURCE_DIR}/pianobooster_blank.ts ABSOLUTE)
list(REMOVE_ITEM TRANSLATIONS_FILES ${full_path_blank_ts})

get_filename_component(full_path_blank_ts ${CMAKE_CURRENT_SOURCE_DIR}/music_blank.ts ABSOLUTE)
list(REMOVE_ITEM TRANSLATIONS_FILES ${full_path_blank_ts})

FIND_PACKAGE(Qt5 REQUIRED COMPONENTS LinguistTools)

QT5_ADD_TRANSLATION(QM_FILES ${TRANSLATIONS_FILES})
ADD_CUSTOM_TARGET(translations ALL DEPENDS ${QM_FILES})

IF (UNIX AND NOT APPLE)
    INSTALL( FILES ${QM_FILES} DESTINATION ${DATA_DIR}/translations )
    INSTALL( FILES langs.json DESTINATION ${DATA_DIR}/translations )
ENDIF (UNIX AND NOT APPLE)

IF (WIN32)
    INSTALL( FILES ${QM_FILES} DESTINATION . )
    INSTALL( FILES langs.json DESTINATION . )
ENDIF (WIN32)

configure_file(${CMAKE_CURRENT_SOURCE_DIR}/langs.json ${CMAKE_CURRENT_BINARY_DIR}/ COPYONLY)

=== music/src/Makefile ===
dirs:= BeginnerCourse BoosterMusic
output:= ../../doc/courses
ABCs:=$(foreach dir, $(dirs), $(wildcard $(dir)/??-*.abc))
MMAs:=$(sort $(foreach dir, $(dirs), $(wildcard $(dir)/??-*.mma)))
MIDs:=$(foreach mma, $(MMAs:.mma=.mid), $(output)/$(mma))
SOLs:=$(foreach abc, $(ABCs:.abc=.solo.mid), $(abc))
SVGs:=$(foreach abc, $(ABCs:.abc=.svg), $(output)/$(abc))
MDs=:$(ABCs:.abc=_en.md)

all: $(output)/README.html

%.html: %.md
	markdown $< > $@

$(output)/README.md: $(SVGs) $(MIDs)
	cat music.md.start > $@
	echo "" >> $@
	sh -c '$(foreach mma, $(MMAs), \
			echo "## $(basename $(notdir $(mma)))"; \
			echo ""; \
			echo "![score]($(basename $(mma)).svg)"; \
			echo ""; \
			[ -f "$(basename $(mma))_en.md" ] && cat "$(basename $(mma))_en.md" || true ; \
			echo ""; \
			echo "[midi file]($(basename $(mma)).mid)" ; \
			echo ""; \
			)' >> "$@"
	cat music.md.end >> $@

$(output)/%.svg: %.abc
	$(foreach dir, $(dirs), mkdir -p $(output)/$(dir);)
	abcm2ps -g -s 0.9 -c "$<" -O "$(output)/$(basename $<).svg"
	mv -f "$(output)/$(basename $<)001.svg" "$(output)/$(basename $<).svg"

%.solo.mid: %.abc
	abc2midi "$<" -o "$@" -RS

$(output)/%.mid: %.mma $(SOLs)
	$(foreach dir, $(dirs), mkdir -p $(output)/$(dir);)
	sh -c 'cd $(dir $<); mma "$(notdir $<)" -o -f "../$@"'

clean:
	rm -f $(SOLs) $(wildcard $(output)/*/*.svg)

cleanall: clean
	rm -fr $(output)

=== debian/changelog ===
pianobooster (0.7.2-1) unstable; urgency=medium

  [ Juhani Numminen ]
  * New upstream release.
  * The software does not use fluidsynth or jack by default anymore.
  * Some cmake options were removed upstream (see BUILD.md).
  * Only install translations deemed complete enough by upstream devs.
  * Drop unnecessary Build-Depends hicolor-icon-theme, libfluidsynth-dev,
    libjack-dev, qt5-qmake, qtchooser.
  * Change mesa-common-dev to libgl-dev since GL/gl.h has moved.
  * Add Rules-Requires-Root: no
  * Bump Standards-Version to 4.5.0. No changes needed.
  * Remove refresh-tr from d/rules. It was first added back when PianoBooster's
    i18n was a Debian-specific modification.

  [ Barak A. Pearlmutter ]
  * explicitly tell qtchooser to use qt5

 -- Barak A. Pearlmutter <bap@debian.org>  Tue, 18 Feb 2020 10:45:28 +0000

=== debian/control ===
Source: pianobooster
Section: games
Priority: optional
Maintainer: Debian Games Team <pkg-games-devel@lists.alioth.debian.org>
Uploaders:
 Miriam Ruiz <miriam@debian.org>,
 Daniel Gimpelevich <daniel@gimpelevich.san-francisco.ca.us>,
 Barak A. Pearlmutter <bap@debian.org>
Build-Depends:
 cmake,
 debhelper-compat (= 12),
 libasound2-dev,
 libftgl-dev,
 libgl-dev,
 libglu1-mesa-dev,
 libqt5opengl5-dev,
 librtmidi-dev,
 qtbase5-dev,
 qtbase5-dev-tools,
 qttools5-dev
Rules-Requires-Root: no
Standards-Version: 4.5.0
Homepage: https://github.com/captnfab/PianoBooster
Vcs-Git: https://salsa.debian.org/games-team/pianobooster.git
Vcs-Browser: https://salsa.debian.org/games-team/pianobooster

Package: pianobooster
Architecture: any
Depends:
 fluid-soundfont-gm,
 fluid-soundfont-gs,
 fonts-dejavu-core,
 hicolor-icon-theme,
 timidity,
 unzip,
 ${misc:Depends},
 ${shlibs:Depends}
Recommends:
 qttranslations5-l10n
Description: Learn the piano just by playing a game
 A MIDI file player/game that displays the musical notes AND teaches you how
 to play the piano.
 .
 PianoBooster is a fun way of playing along with a musical accompaniment and
 at the same time learning the basics of reading musical notation.
 The difference between playing along to a CD or a standard MIDI file
 is that PianoBooster listens and reacts to what you are playing on a
 MIDI keyboard.
 .
 To run Piano Booster you need a MIDI Piano Keyboard and a MIDI interface
 for the PC. If you don't have a MIDI keyboard you can still try out
 PianoBooster, using the PC keyboard ('x' is middle C), but a MIDI piano
 is really recommended.

=== debian/rules ===
#!/usr/bin/make -f

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
export QT_SELECT = 5

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- \
		-DCMAKE_INSTALL_BINDIR=/usr/games \
		-DUSE_SYSTEM_FONT=ON \
		-DWITH_MAN=ON \
		-DNO_LICENSE=ON \
		-DNO_CHANGELOG=ON

# Not much benefit from compressing the little markdown documentation files.
override_dh_compress:
	dh_compress --exclude=.md

## pianobooster 0.7.2b

=== debian/changelog ===
pianobooster (0.7.2b-1) unstable; urgency=medium

  * New upstream release
  * Set upstream metadata fields: Repository.
  * Remove obsolete field Name from debian/upstream/metadata (already
    present in machine-readable debian/copyright).
  * Fix day-of-week for changelog entry 0.6.7~svn156-0ppa2~trusty.

 -- Barak A. Pearlmutter <bap@debian.org>  Wed, 04 Mar 2020 12:26:02 +0000

## pianobooster 1.0.0

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -1,9 +1,14 @@
 # Cmake File for Piano Booster
 
-option(USE_FTGL "build with ftgl" ON)
-option(USE_JACK "build with Jack (Only required of BSD Unix)" OFF)
-option(USE_BUNDLED_RTMIDI "build with bundled rtmidi (for older distributions only)" OFF)
-option(USE_SYSTEM_FONT "build with system font" OFF)
+option(WITH_INTERNAL_FLUIDSYNTH "Build with an internal FluidSynth sound generator" ON)
+option(USE_FTGL "Build with ftgl for notes localization" ON)
+option(USE_SYSTEM_FONT "Build with system font" OFF)
+option(USE_JACK "Build with Jack (Only required for BSD Unix)" OFF)
+if(${CMAKE_SYSTEM} MATCHES "Linux")
+   option(USE_BUNDLED_RTMIDI "Build with bundled rtmidi (for older distributions only)" OFF)
+else()
+   option(USE_BUNDLED_RTMIDI "Build with bundled rtmidi" ON)
+endif()
 
 cmake_minimum_required(VERSION 2.4)
 if(COMMAND cmake_policy)
@@ -12,7 +17,6 @@
 
 if(WIN32)
     MESSAGE("GUI system is WIN32 ${CMAKE_GENERATOR}")
-    SET(CMAKE_COLOR_MAKEFILE OFF)
 endif(WIN32)
 
 # set project's name
@@ -24,9 +28,6 @@
 # enable warnings
 add_compile_options(-Wall)
 
-if(USE_FONT)
-    add_compile_options("-DUSE_FONT=\"${USE_FONT}\"")
-endif()
 
 add_compile_options("-DPREFIX=\"${CMAKE_INSTALL_PREFIX}\"")
 
@@ -45,17 +46,23 @@
 
 FIND_PACKAGE( OpenGL REQUIRED )
 
-include(FindPkgConfig)
-FIND_PACKAGE( PkgConfig REQUIRED )
+if(NOT WIN32)
+   # the `pkg_check_modules` function is created with this call
+   include(FindPkgConfig)
+   FIND_PACKAGE( PkgConfig REQUIRED )
+endif()
 
 if(USE_FTGL)
-   pkg_check_modules(FTGL ftgl)
-   if(NOT FTGL_FOUND)
-      MESSAGE(FATAL_ERROR "FTGL was not found")
-   endif(NOT FTGL_FOUND)
-
-   SET(FTGL_INCLUDE_DIR ${FTGL_INCLUDE_DIRS})
-   SET(FTGL_LIBRARY ${FTGL_LIBRARIES})
+   if(NOT WIN32)
+      pkg_check_modules(FTGL ftgl)
+      if(NOT FTGL_FOUND)
+         MESSAGE(FATAL_ERROR "FTGL was not found")
+      endif(NOT FTGL_FOUND)
+      SET(FTGL_INCLUDE_DIR ${FTGL_INCLUDE_DIRS})
+      SET(FTGL_LIBRARY ${FTGL_LIBRARIES})
+   else()
+      FIND_PACKAGE( ftgl REQUIRED )
+   endif()
 else(USE_FTGL)
     add_compile_options("-DNO_USE_FTGL")
 endif(USE_FTGL)
@@ -84,30 +91,26 @@
 
 if(${CMAKE_SYSTEM} MATCHES "Darwin")
     ADD_DEFINITIONS(-D__MACOSX_CORE__)
+    ADD_DEFINITIONS(-std=c++11)
     LINK_LIBRARIES("-framework CoreMidi -framework CoreAudio -framework CoreFoundation -framework OpenGL")
 endif(${CMAKE_SYSTEM} MATCHES "Darwin")
 
-if(EXPERIMENTAL_USE_FLUIDSYNTH)
-    ADD_DEFINITIONS(-DEXPERIMENTAL_USE_FLUIDSYNTH)
-    MESSAGE("Building using fluidsynth")
+if(WITH_INTERNAL_FLUIDSYNTH)
+    if(NOT WIN32)
+        pkg_check_modules(FLUIDSYNTH fluidsynth)
+
+        if(NOT FLUIDSYNTH_FOUND)
+           MESSAGE(FATAL_ERROR "FLUIDSYNTH was not found")
+        endif(NOT FLUIDSYNTH_FOUND)
+        INCLUDE_DIRECTORIES(${FLUIDSYNTH_INCLUDE_DIRS})
+        SET(FLUIDSYNTH_LIBRARY ${FLUIDSYNTH_LIBRARIES})
+    else()
+        FIND_PACKAGE( fluidsynth REQUIRED )
+    endif()
+    ADD_DEFINITIONS(-DWITH_INTERNAL_FLUIDSYNTH)
+    MESSAGE("Building with internal fluidsynth")
     SET( PB_BASE_SRCS MidiDeviceFluidSynth.cpp )
-
-    if(FLUIDSYNTH_INPLACE_DIR)
-        INCLUDE_DIRECTORIES(${FLUIDSYNTH_INPLACE_DIR}/include/)
-        if(WIN32)
-            LINK_LIBRARIES( ${FLUIDSYNTH_INPLACE_DIR}/src/.libs/libfluidsynth.dll.a)
-        endif(WIN32)
-        if(UNIX)
-            LINK_LIBRARIES(${FLUIDSYNTH_INPLACE_DIR}/src/.libs/libfluidsynth.so)
-        endif(UNIX)
-    else(FLUIDSYNTH_INPLACE_DIR)
-        pkg_check_modules(FLUIDSYNTH fluidsynth)
-        if(NOT FLUIDSYNTH_FOUND)
-            MESSAGE(FATAL_ERROR "FLUIDSYNTH was not found")
-        endif(NOT FLUIDSYNTH_FOUND)
-        LINK_LIBRARIES( fluidsynth)
-    endif(FLUIDSYNTH_INPLACE_DIR)
-endif(EXPERIMENTAL_USE_FLUIDSYNTH)
+endif(WITH_INTERNAL_FLUIDSYNTH)
 
 # we need this to be able to include headers produced by uic in our code
 # (CMAKE_BINARY_DIR holds a path to the build directory, while INCLUDE_DIRECTORIES() works just like INCLUDEPATH from qmake)
@@ -117,7 +120,6 @@
     Chord.cpp Tempo.cpp MidiDevice.cpp MidiDeviceRt.cpp ${PB_BASE_SRCS})
 SET(PB_BASE_HDR MidiFile.h MidiTrack.h Song.h Conductor.h Rating.h Util.h
     Chord.h Tempo.h MidiDevice.h)
-
 
 if(USE_JACK)
     # Check for Jack
@@ -141,9 +143,11 @@
     set(PB_BASE_SRCS ${PB_BASE_SRCS} 3rdparty/rtmidi/RtMidi.cpp)
     set(PB_BASE_HDR ${PB_BASE_HDR} 3rdparty/rtmidi/RtMidi.h)
 else()
-    pkg_check_modules(RTMIDI REQUIRED rtmidi)
+    pkg_check_modules(RTMIDI rtmidi)
+    if(NOT RTMIDI_FOUND)
+        MESSAGE(FATAL_ERROR "rtmidi not found (Try building with option USE_BUNDLED_RTMIDI=ON)")
+    endif(NOT RTMIDI_FOUND)
     include_directories(${RTMIDI_INCLUDE_DIRS})
-    link_directories(${RTMIDI_LIBRARY_DIRS})
 endif()
 
 # with SET() command you can change variables or define new ones
@@ -213,19 +217,40 @@
 
 # here we instruct CMake to build "pianobooster" executable from all of the source files
 if(APPLE)
-    ADD_EXECUTABLE( pianobooster MACOSX_BUNDLE ${PIANOBOOSTER_SRCS}
+    # the property added the pianobooster icon to Info.plist
+    set(MACOSX_BUNDLE_ICON_FILE pianobooster.icns)
+
+    # Tells CMake where to find and install the pianobooster icon
+    set(pianobooster_ICON ${CMAKE_CURRENT_SOURCE_DIR}/../icons/MacOS/pianobooster.icns)
+    set_source_files_properties(${pianobooster_ICON} PROPERTIES MACOSX_PACKAGE_LOCATION "Resources")
+
+    set(pianobooster_TRANSLATIONS ${CMAKE_CURRENT_BINARY_DIR}/translations/langs.json)
+    set_source_files_properties(${pianobooster_TRANSLATIONS} PROPERTIES MACOSX_PACKAGE_LOCATION "Resources/translations")
+
+    set(pianobooster_MUSIC ${CMAKE_CURRENT_SOURCE_DIR}/../music/BoosterMusicBooks.zip)
+    set_source_files_properties(${pianobooster_MUSIC} PROPERTIES MACOSX_PACKAGE_LOCATION "Resources/music")
+    set(pianobooster_FONT ${CMAKE_CURRENT_SOURCE_DIR}/fonts/DejaVuSans.ttf)
+    set_source_files_properties(${pianobooster_FONT} PROPERTIES MACOSX_PACKAGE_LOCATION "Resources/fonts")
+
+    ADD_EXECUTABLE( pianobooster MACOSX_BUNDLE
+        ${pianobooster_ICON} ${pianobooster_TRANSLATIONS}
+        ${pianobooster_MUSIC} ${pianobooster_FONT}
+        ${PIANOBOOSTER_SRCS}
         ${PIANOBOOSTER_MOC_SRCS} ${PIANOBOOSTER_RC_SRCS}
         ${PIANOBOOSTER_UI_HDRS} ${PIANOBOOSTER_RCS} )
+
+    add_custom_target(install-translations cp -R -v ${CMAKE_CURRENT_BINARY_DIR}/translations/*.qm ${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}.app/Contents/Resources/translations)
+
 endif(APPLE)
 
-if(UNIX)
+if(UNIX AND NOT APPLE)
     ADD_EXECUTABLE( pianobooster ${PIANOBOOSTER_SRCS}
         ${PIANOBOOSTER_MOC_SRCS} ${PIANOBOOSTER_RC_SRCS}
         ${PIANOBOOSTER_UI_HDRS} ${PIANOBOOSTER_RCS} )
-endif(UNIX)
+endif(UNIX AND NOT APPLE)
 
 if(WIN32)
-    ADD_EXECUTABLE( pianobooster WIN32 ${PIANOBOOSTER_SRCS}
+    ADD_EXECUTABLE( pianobooster ${PIANOBOOSTER_SRCS}
         ${PIANOBOOSTER_MOC_SRCS} ${PIANOBOOSTER_RC_SRCS}
         ${PIANOBOOSTER_UI_HDRS} ${PIANOBOOSTER_RCS} )
     SET_TARGET_PROPERTIES(pianobooster PROPERTIES LINK_FLAGS "-mwindows")
@@ -236,12 +261,14 @@
 if(${CMAKE_VERSION} VERSION_LESS "3.13.0")
     message("Please consider to switch to CMake 3.13.0")
 else()
-    target_link_directories(pianobooster PUBLIC ${FTGL_LIBRARY_DIRS} ${JACK_LIBRARY_DIRS})
-endif()
-target_link_libraries (pianobooster Qt5::Widgets Qt5::Xml Qt5::OpenGL ${OPENGL_LIBRARIES} ${FTGL_LIBRARY} ${RTMIDI_LIBRARIES} ${JACK_LIBRARY})
-
-INSTALL( FILES ../pianobooster.desktop DESTINATION share/applications )
-INSTALL(TARGETS pianobooster RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR})
+    target_link_directories(pianobooster PUBLIC ${FTGL_LIBRARY_DIRS} ${JACK_LIBRARY_DIRS} ${FLUIDSYNTH_LIBRARY_DIRS})
+endif()
+target_link_libraries (pianobooster Qt5::Widgets Qt5::Xml Qt5::OpenGL ${OPENGL_LIBRARIES} ${FTGL_LIBRARY} ${RTMIDI_LIBRARIES} ${JACK_LIBRARY} ${FLUIDSYNTH_LIBRARY} ${RTMIDI_LIBRARY})
+
+if(NOT APPLE)
+    INSTALL( FILES ../pianobooster.desktop DESTINATION share/applications )
+    INSTALL(TARGETS pianobooster RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR})
+endif(NOT APPLE)
 
 if(NOT NO_DOCS)
     INSTALL( FILES ../README.md DESTINATION share/doc/pianobooster/ )
@@ -272,12 +299,9 @@
     INSTALL( FILES ../music/BoosterMusicBooks.zip DESTINATION . )
 endif(WIN32)
 
-if(USE_FONT)
-    INSTALL ( FILES ${USE_FONT} DESTINATION ${DATA_DIR}/fonts)
-endif(USE_FONT)
-
 if(NOT USE_SYSTEM_FONT)
-    INSTALL ( FILES fonts/DejaVuSans.ttf DESTINATION ${DATA_DIR}/fonts)
+    configure_file(fonts/DejaVuSans.ttf ${CMAKE_CURRENT_BINARY_DIR}/fonts/DejaVuSans.ttf COPYONLY)
+    INSTALL ( FILES fonts/DejaVuSans.ttf DESTINATION ${DATA_DIR}/fonts/)
 endif(NOT USE_SYSTEM_FONT)
 
 if(NOT NO_LANGS)
@@ -292,3 +316,5 @@
     ADD_DEFINITIONS(-DPB_LOG_TIMING)
 endif()
 
+configure_file(${CMAKE_CURRENT_SOURCE_DIR}/../music/BoosterMusicBooks.zip ${CMAKE_CURRENT_BINARY_DIR}/ COPYONLY)
+

=== translations/CMakeLists.txt ===
--- 
+++ 
@@ -17,18 +17,13 @@
      pianobooster_sv.ts
      pianobooster_uk.ts
      pianobooster_zh.ts
-     music_ru.ts
-     music_uk.ts
 )
 
 if(INSTALL_ALL_LANGS)
-file (GLOB TRANSLATIONS_FILES "*.ts")   
+file (GLOB TRANSLATIONS_FILES "*.ts")
 endif()
 
 get_filename_component(full_path_blank_ts ${CMAKE_CURRENT_SOURCE_DIR}/pianobooster_blank.ts ABSOLUTE)
-list(REMOVE_ITEM TRANSLATIONS_FILES ${full_path_blank_ts})
-
-get_filename_component(full_path_blank_ts ${CMAKE_CURRENT_SOURCE_DIR}/music_blank.ts ABSOLUTE)
 list(REMOVE_ITEM TRANSLATIONS_FILES ${full_path_blank_ts})
 
 FIND_PACKAGE(Qt5 REQUIRED COMPONENTS LinguistTools)

=== debian/changelog ===
pianobooster (1.0.0-4.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Fix FTBFS with CMake 4. (Closes: #1113405)

 -- Adrian Bunk <bunk@debian.org>  Sat, 11 Oct 2025 15:40:35 +0300

pianobooster (1.0.0-4) unstable; urgency=medium

  * Team Upload
  * Remove old dependency on timidity (Closes: #1036529)
  * Use team new canonical ML name in d/control

 -- Alexandre Detiste <tchet@debian.org>  Sun, 17 Nov 2024 16:16:33 +0100

pianobooster (1.0.0-3) unstable; urgency=medium

  * Set upstream metadata fields: Bug-Database, Bug-Submit, Repository-Browse.
  * Update standards version to 4.6.2, no changes needed.
  * Track upstream development
  * Add course to doc-base

 -- Barak A. Pearlmutter <bap@debian.org>  Sun, 19 Feb 2023 12:55:44 +0000

pianobooster (1.0.0-2) unstable; urgency=medium

  * Actually enable internal interface to fluidsynth

 -- Barak A. Pearlmutter <bap@debian.org>  Mon, 21 Dec 2020 21:01:09 +0000

pianobooster (1.0.0-1) unstable; urgency=medium

  * debhelper 13
  * New upstream release
  * Bump policy
  * Use system libfluidsynth

 -- Barak A. Pearlmutter <bap@debian.org>  Mon, 21 Dec 2020 11:20:22 +0000

=== debian/control ===
--- 
+++ 
@@ -8,8 +8,9 @@
  Barak A. Pearlmutter <bap@debian.org>
 Build-Depends:
  cmake,
- debhelper-compat (= 12),
+ debhelper-compat (= 13),
  libasound2-dev,
+ libfluidsynth-dev,
  libftgl-dev,
  libgl-dev,
  libglu1-mesa-dev,
@@ -19,7 +20,7 @@
  qtbase5-dev-tools,
  qttools5-dev
 Rules-Requires-Root: no
-Standards-Version: 4.5.0
+Standards-Version: 4.6.2
 Homepage: https://github.com/captnfab/PianoBooster
 Vcs-Git: https://salsa.debian.org/games-team/pianobooster.git
 Vcs-Browser: https://salsa.debian.org/games-team/pianobooster
@@ -31,7 +32,6 @@
  fluid-soundfont-gs,
  fonts-dejavu-core,
  hicolor-icon-theme,
- timidity,
  unzip,
  ${misc:Depends},
  ${shlibs:Depends}

=== debian/rules ===
--- 
+++ 
@@ -12,6 +12,7 @@
 override_dh_auto_configure:
 	dh_auto_configure -- \
 		-DCMAKE_INSTALL_BINDIR=/usr/games \
+		-DWITH_INTERNAL_FLUIDSYNTH=ON \
 		-DUSE_SYSTEM_FONT=ON \
 		-DWITH_MAN=ON \
 		-DNO_LICENSE=ON \

=== debian/watch ===
# Watch control file for uscan
# Run the "uscan" command to check for upstream updates and more.
# See uscan(1) for format

version=4
https://github.com/captnfab/PianoBooster/tags \
   (?:.*?/)?v?@ANY_VERSION@@ARCHIVE_EXT@ debian uupdate
